package controller

import (
	"fmt"

	"github.com/gofiber/fiber/v2"
	"ulmer-furs.de/pretix-proxy/v2/app/service"
	"ulmer-furs.de/pretix-proxy/v2/app/util"
	"ulmer-furs.de/pretix-proxy/v2/entities"
)

func PostPretixRoleQuestion(c *fiber.Ctx) error {
	data := new(entities.Pretix_Webhook)
	if err := c.BodyParser(data); err != nil {
		return c.Status(fiber.ErrBadRequest.Code).SendString(err.Error())
	}
	//TODO: Update attendies from pretix
	pretixOrders, err := util.GetPretixOrders(&data.Organizer, &data.Event)
	_ = pretixOrders
	if err != nil {
		return c.Status(500).SendString("Internal Server Error")
	}
	event, err := service.Get_db_event_by_event(data.Event)
	if err != nil {
		return c.Status(fiber.StatusNotFound).SendString("Event not found")
	}
	attendies, err := util.GetAttendiesFromPretixJsonWithRoleQuestion(pretixOrders, &event)
	if err != nil {
		fmt.Println(err)
	}
	if err := service.DeleteAttendiesByEvent(event); err != nil {
		fmt.Println(err)
	}
	for _, attendie := range attendies {
		if err := service.CreateNewAttendie(attendie); err != nil {
			fmt.Print(err)
		}
	}
	return c.SendStatus(fiber.StatusOK)
}

func PostPretixRoleProduct(c *fiber.Ctx) error {
	data := new(entities.Pretix_Webhook)
	if err := c.BodyParser(data); err != nil {
		return c.Status(fiber.ErrBadRequest.Code).SendString(err.Error())
	}
	//TODO: Update attendies from pretix
	pretixOrders, err := util.GetPretixOrders(&data.Organizer, &data.Event)
	_ = pretixOrders
	if err != nil {
		return c.Status(500).SendString("Internal Server Error")
	}
	event, err := service.Get_db_event_by_event(data.Event)
	if err != nil {
		return c.Status(fiber.StatusNotFound).SendString("Event not found")
	}
	fmt.Printf("%+v\n", pretixOrders)
	attendies, err := util.GetAttendiesFromPretixJsonWithRoleProduct(pretixOrders, &event)
	fmt.Printf("%+v\n", attendies)
	if err != nil {
		fmt.Println(err)
	}
	if err := service.DeleteAttendiesByEvent(event); err != nil {
		fmt.Println(err)
	}
	for _, attendie := range attendies {
		if err := service.CreateNewAttendie(attendie); err != nil {
			fmt.Print(err)
		}
	}
	return c.SendStatus(fiber.StatusOK)
}
